-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Written by Kimberly L. Tripp - all rights reserved.
-- 
-- For more scripts and sample code, check out 
-- 	http://www.SQLSkills.com
-- For "More than Just Training," see the Industry Experts at 
-- 	http://www.SolidQualityLearning.com
--
-- Disclaimer - Thoroughly test this script, execute at your own risk.
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

/* Worst Case Scenario */
BEGIN TRAN
	SELECT @balance = balance from checking 
	Check with - debit
	Then update
COMMIT 

/* No data Integrity Issues but not the best performing! */
BEGIN TRAN
	update checking (allow debit)
	select @balance = balance from checking 
	IF @balance >= 0
		COMMIT
	 
/* The best option! */
BEGIN TRAN
UPDATE checking 
	SET @balance = balance = balance - @debit
IF @balance >= 0
	COMMIT
ELSE
BEGIN
-- 	do all the other banking stuff
-- 	Over Draft Protection Checking
-- 	Visa for Charges
	ELSE
	ROLLBACK
END